﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;

namespace PUtility
{
    public class PUtil
    {
		private static readonly string characters = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

		public static string GetRandomString(int length = 5)
		{
			char[] randCharArr = new char[length];
			Random rand = new Random();
			for (int i = 0; i < length; i++)
			{
				randCharArr[i] = characters[rand.Next(characters.Length)];
			}

			return new string(randCharArr);
		}

        public static void ScrollToEnd(TextBox target)
		{
            if (target == null)
                return;

            target.SelectionStart = target.Text.Length;
            target.ScrollToCaret();
        }

		public static byte[] ImageToByteArray(Image image)
		{
			using (MemoryStream ms = new MemoryStream())
			{
				image.Save(ms, image.RawFormat);
				return ms.ToArray();
			}
		}

		public static Bitmap ByteToImage(byte[] imgByteArray)
		{
			using (MemoryStream ms = new MemoryStream(imgByteArray))
			{
				Bitmap img = Image.FromStream(ms) as Bitmap;
				return img;
			}
		}

		public static void SaveImage(string fileName, Image img, ImageFormat format)
		{
			using (Image saveImage = new Bitmap(img))
			{
				saveImage.Save(fileName, format);
			}
		}
	}
}
